#import "TestX.h"

@implementation TestX

NSString *mode = @"rootless";
NSString *testx = @"/usr/X11R6/bin/testx";

- (IBAction)XAppleX11Element:(id)sender
{
    NSTask *task = [[NSTask alloc] init];
    NSArray *arguments;
    NSString *argument0 = @"element";
    NSString *argument1 = @"apple";
    NSString *argument2;
    NSPipe *outputPipe = [[NSPipe alloc] init];
    NSFileHandle *outputHandle = [[outputPipe fileHandleForReading] retain];
    NSData *outputData = nil; 
    NSMutableString *outputString = nil;
    int i = [sender state];
    [task setStandardOutput: outputPipe];
    [task setStandardError: [task standardOutput]];
    [task setLaunchPath: testx];
    if (i == 0)
    {
        argument2 = @"false";
    }
    else
    {
        argument2 = @"true";
    }
    arguments = [NSArray arrayWithObjects: argument0, argument1, argument2, nil];
    [task setArguments: arguments];
    [task launch];
    outputData = [outputHandle readDataToEndOfFile];
    outputString = [[NSString alloc] initWithData: outputData encoding: NSASCIIStringEncoding];
    [task release];
    [outputPipe release];
    [XScriptOutput setStringValue: outputString];
}

- (IBAction)XMode:(id)sender
{
    int i = [sender selectedRow];
    if (i == 0)
    {
        mode = @"rootless";
    }
    else
    {
        if (i == 1)
        {
            mode = @"fullscreen";
        }
        else
        {
            mode = @"applex11";
        }
    }
}

- (IBAction)XOroborOSXElement:(id)sender
{
    NSTask *task = [[NSTask alloc] init];
    NSArray *arguments;
    NSString *argument0 = @"element";
    NSString *argument1 = @"oroborosx";
    NSString *argument2;
    NSPipe *outputPipe = [[NSPipe alloc] init];
    NSFileHandle *outputHandle = [[outputPipe fileHandleForReading] retain];
    NSData *outputData = nil; 
    NSMutableString *outputString = nil;
    int i = [sender state];
    [task setStandardOutput: outputPipe];
    [task setStandardError: [task standardOutput]];
    [task setLaunchPath: testx];
    if (i == 0)
    {
        argument2 = @"false";
    }
    else
    {
        argument2 = @"true";
    }
    arguments = [NSArray arrayWithObjects: argument0, argument1, argument2, nil];
    [task setArguments: arguments];
    [task launch];
    outputData = [outputHandle readDataToEndOfFile];
    outputString = [[NSString alloc] initWithData: outputData encoding: NSASCIIStringEncoding];
    [task release];
    [outputPipe release];
    [XScriptOutput setStringValue: outputString];
}

- (IBAction)XRestart:(id)sender
{
    NSTask *task = [[NSTask alloc] init];
    NSArray *arguments = [NSArray arrayWithObjects: @"shutdown", mode, nil];
    NSPipe *outputPipe = [[NSPipe alloc] init];
    NSFileHandle *outputHandle = [[outputPipe fileHandleForReading] retain];
    NSData *outputData = nil;
    NSMutableString *outputString = nil;
    [task setStandardOutput: outputPipe];
    [task setStandardError: [task standardOutput]];
    [task setLaunchPath: testx];
    [task setArguments: arguments];
    [task launch];
    outputData = [outputHandle readDataToEndOfFile];
    outputString = [[NSString alloc] initWithData: outputData encoding: NSASCIIStringEncoding];
    [task release];
    [outputPipe release];
    [XScriptOutput setStringValue: outputString];
}

- (IBAction)XSetWindowManager:(id)sender
{
    NSTask *task = [[NSTask alloc] init];
    NSArray *arguments;
    NSString *argument0 = @"manager";
    NSString *argument1 = [XWindowManager stringValue];
    NSPipe *outputPipe = [[NSPipe alloc] init];
    NSFileHandle *outputHandle = [[outputPipe fileHandleForReading] retain];
    NSData *outputData = nil;
    NSMutableString *outputString = nil;
    [task setStandardOutput: outputPipe];
    [task setStandardError: [task standardOutput]];
    [task setLaunchPath: testx];
    arguments = [NSArray arrayWithObjects: argument0, argument1, nil];
    [task setArguments: arguments];
    [task launch];
    outputData = [outputHandle readDataToEndOfFile];
    outputString = [[NSString alloc] initWithData: outputData encoding: NSASCIIStringEncoding];
    [task release];
    [outputPipe release];
    [XScriptOutput setStringValue: outputString];
}   

- (IBAction)XShutdown:(id)sender
{
    NSTask *task = [[NSTask alloc] init];
    NSArray *arguments = [NSArray arrayWithObjects: @"shutdown", nil];
    NSPipe *outputPipe = [[NSPipe alloc] init];
    NSFileHandle *outputHandle = [[outputPipe fileHandleForReading] retain];
    NSData *outputData = nil;
    NSMutableString *outputString = nil;
    [task setStandardOutput: outputPipe];
    [task setStandardError: [task standardOutput]];
    [task setLaunchPath: testx];
    [task setArguments: arguments];
    [task launch];
    outputData = [outputHandle readDataToEndOfFile];
    outputString = [[NSString alloc] initWithData: outputData encoding: NSASCIIStringEncoding];
    [task release];
    [outputPipe release];
    [XScriptOutput setStringValue: outputString];
}

- (IBAction)XStart:(id)sender
{
    NSTask *task = [[NSTask alloc] init];
    NSArray *arguments = [NSArray arrayWithObjects: mode, nil];
    NSPipe *outputPipe = [[NSPipe alloc] init];
    NSFileHandle *outputHandle = [[outputPipe fileHandleForReading] retain];
    NSData *outputData = nil;
    NSMutableString *outputString = nil;
    [task setStandardOutput: outputPipe];
    [task setStandardError: [task standardOutput]];
    [task setLaunchPath: testx];
    [task setArguments: arguments];
    [task launch];
    outputData = [outputHandle readDataToEndOfFile];
    outputString = [[NSString alloc] initWithData: outputData encoding: NSASCIIStringEncoding];
    [task release];
    [outputPipe release];
    [XScriptOutput setStringValue: outputString];
}

- (IBAction)XStatus:(id)sender
{
    NSTask *task = [[NSTask alloc] init];
    NSArray *arguments = [NSArray arrayWithObjects: @"status", nil];
    NSPipe *outputPipe = [[NSPipe alloc] init];
    NSFileHandle *outputHandle = [[outputPipe fileHandleForReading] retain];
    NSData *outputData = nil;
    NSMutableString *outputString = nil;
    [task setStandardOutput: outputPipe];
    [task setStandardError: [task standardOutput]];
    [task setLaunchPath: testx];
    [task setArguments: arguments];
    [task launch];
    outputData = [outputHandle readDataToEndOfFile];
    outputString = [[NSString alloc] initWithData: outputData encoding: NSASCIIStringEncoding];
    [task release];
    [outputPipe release];
    [XScriptOutput setStringValue: outputString];
}

- (IBAction)XXDarwinElement:(id)sender
{
    NSTask *task = [[NSTask alloc] init];
    NSArray *arguments;
    NSString *argument0 = @"element";
    NSString *argument1 = @"xdarwin";
    NSString *argument2;
    NSPipe *outputPipe = [[NSPipe alloc] init];
    NSFileHandle *outputHandle = [[outputPipe fileHandleForReading] retain];
    NSData *outputData = nil; 
    NSMutableString *outputString = nil;
    int i = [sender state];
    [task setStandardOutput: outputPipe];
    [task setStandardError: [task standardOutput]];
    [task setLaunchPath: testx];
    if (i == 0)
    {
        argument2 = @"false";
    }
    else
    {
        argument2 = @"true";
    }
    arguments = [NSArray arrayWithObjects: argument0, argument1, argument2, nil];
    [task setArguments: arguments];
    [task launch];
    outputData = [outputHandle readDataToEndOfFile];
    outputString = [[NSString alloc] initWithData: outputData encoding: NSASCIIStringEncoding];
    [task release];
    [outputPipe release];
    [XScriptOutput setStringValue: outputString];
}

@end
